//	xExv
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATmega88P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	DP	G	F	E	D	C	B	A		7ZÕZOg
portC	x	x	-	-	k4	k3	k2	k1		7ZǑ
portD	HT	-	-	-	-	fB	fG	fR		HuTemZT[,tJ[LED

yATmega88Pz
|CCCCCC---BBBBB|
|543210GRV54321|
>              |
|601234VG675670|
|CDDDDD--BBDDDB|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62), Hi:11011111(DF)
Low: 01100010 (62)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001 (F9)
          ||+-- BOOTRST f[^V[gQ
          ++-- BOOTSZ[1:0] f[^V[gQ

yrhz
Atmel Studio 6 (Version: 6.2.1502 - Service Pack 1)
AVR8_Toolchain_Version:3.4.5.1522 GCC_VERSION:4.8.1
ATmega88P	500kHzi8MHz/16j

yXVz
2015/09/23	v1.00	
		Program Memory Usage 	:	898 bytes   11.0 % Full
		Data Memory Usage 		:	7 bytes   0.7 % Full

2015/09/27	v1.10
		Program Memory Usage 	:	976 bytes   11.9 % Full
		Data Memory Usage 		:	7 bytes   0.7 % Full
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "dht11lib.h"

static	void	ResetTimerParam();
static	void	DisplsyOff();
static	void	LedOff();
static	void	SetSegValue(uint8_t hutemType, uint8_t hutemValue, uint8_t hutemUnit);
static	uint8_t	GetRgbLedColor(uint8_t loopCount, uint8_t colorStep, uint8_t colorBitValue);

//7ZÕp^[`
PROGMEM const uint8_t	SEGCHAR[]	=
{
//	0b0GFEDCBA
	0b00111111,		//0
	0b00000110,		//1
	0b01011011,		//2
	0b01001111,		//3
	0b01100110,		//4
	0b01101101,		//5
	0b01111101,		//6
	0b00100111,		//7
	0b01111111,		//8
	0b01101111,		//9
	0b00000000,		//null
	0b01110100,		//h
	0b01011000,		//c
	0b01111000,		//t
	0b01110011		//P
};

//SEGCHAR[]wCfbNX
enum	ESegIndex
{
	SEGIDX_NULL	= 10,
	SEGIDX_h,
	SEGIDX_c,
	SEGIDX_t,
	SEGIDX_P
};

//SegDP̃}XN
#define	SEG_DP	0b10000000

//7ZO̎gp̃}XN
#define	SEG_KETA_MASK	0b00001111

//7ZOLEĎʒu
enum	ESegKeta
{
	LED1 = 0,	//1([)
	LED2,	//2
	LED3,	//3
	LED4	//4(E[)
};

//7ZOLEDɏo͂镶p^[̃CfbNXi[z
static	uint8_t	segidx[4];

//RGB-LEDI/Os
#define RGBLED_BV_R	0b00000001
#define RGBLED_BV_G	0b00000010
#define RGBLED_BV_B	0b00000100
#define RGBLED_MASK	(RGBLED_BV_R | RGBLED_BV_G | RGBLED_BV_B)

//Ԋu(b)
#define MEASUREMENT_INTERVAL_SEC	60

//\e؂ւ̃x
enum	EShowValueType
{
	VALUETYPE_TEMPERATUE = 0,
	VALUETYPE_HUMIDITY
};

//荞݂ő삷ϐ
volatile	uint8_t	showValueType;	//\e؂ւ
volatile	uint8_t	timerCount;		//oߎԂJE^
volatile	uint8_t	doMeasure;		//wtO

//16bit^C}荞݁i5bԊuŌĂяoj
ISR(TIMER1_COMPA_vect)
{
	showValueType = 1 - showValueType;
	
	if (++timerCount >= (MEASUREMENT_INTERVAL_SEC / 5))
	{
		doMeasure = 1;
	}
}

int main(void)
{
	uint8_t	humidity, temperature;	//xEx̑l
	uint8_t	segDP;			//7ZOLEDDP̏o	SEG_DP:o͂	0:o͂Ȃ
	uint8_t	keta = LED1;	//7ZOLEĎʒu		ESegKeta̒l
	uint8_t	loopCount = 0, colorStep;	//RGB-LED̐F߂JE^AF̒iK
	uint8_t	rgbLedColor;	//RGB-LED̐Fi|[gւ̏o͒lj
	uint8_t	i;
	
	_delay_ms(100);
	
	//gݒ肷
	cli();
	CLKPR = (1 << CLKPCE);
	CLKPR = 0b0100;		//8MHz16=500kHz
	
	//d͍팸
	//Power Reduction TWI, Power Reduction Timer/Counter2, Power Reduction Timer/Counter0,
	//Power Reduction Serial Peripheral Interface, Power Reduction USART0, Power Reduction ADC
	PRR = (1 << PRTWI) | (1 << PRTIM2) | (1 << PRTIM0) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRADC);
	ACSR = (1 << ACD);	//Analog Comparator Disable
	
	//|[gݒ肷
	DDRB = 0b11111111;
	DDRC = 0b00001111;
	DDRD = RGBLED_MASK;
	PORTC = 0b00110000;		//gpsvAbv

	//16bit^C}[Zbg
	//TCCR1B:WGM13,WGM12; TCCR1A:WGM11,WGM10 = 0100:CTC
	//TCCR1B:CS12,CS11,CS10 = 001:Ȃ, 010:8, 011:64, 100:256, 101:1024
	TCCR1A	= (0b00 << WGM10);
	TCCR1B	= (0b01 << WGM12) | (0b101 << CS10);
	//OCR1A	= 4883UL - 1;		//1MHz/1024 = 976.56JEg/b  5b4882.8JEgA60b58593.75JEg
	OCR1A	= 2441UL - 1;		//500kHz/1024 = 488.28JEg/b  5b2441.4JEgA60b29296.87JEg
	TIMSK1	= (1 << OCIE1A);	//rv荞݂
	
	//DHT11Ԃőҋ@
	DHT11_Ready();
	for (i = 0; i < 10; i++) { _delay_ms(100); }	//O1b҂
	
	//NA񊄂荞ݔOɑE\悤p[^w肷
	doMeasure = 1;
	showValueType = VALUETYPE_TEMPERATUE;
	
	while (1)
    {
		//RGB-LED܂Ԃ̂ŁA邳̂ߖ_̏Ԃ݂
		//loopCount0`4̊Ԃ͐Fݒ肵Aȍ~̊Ԃ͖_Ƃ
		loopCount = (loopCount + 1) % 15;	//0`4;5`(n-1)JԂJE^

		//^C~OĎ
		if (doMeasure)
		{
			cli();	//荞ݒ~
			DisplsyOff();
			LedOff();
			
			//xEx𑪒肷
			DHT11_GetValue(&humidity, &temperature);
			
			ResetTimerParam();
			sei();	//荞݋
		}
		
		//\eZbg
		if (showValueType == VALUETYPE_TEMPERATUE)
		{
			SetSegValue(SEGIDX_t, temperature, SEGIDX_c);
			
			colorStep = temperature / 10;
			rgbLedColor = (4 < loopCount) ? 0 : GetRgbLedColor(loopCount, colorStep, RGBLED_BV_R);
		}
		else
		{
			SetSegValue(SEGIDX_h, humidity, SEGIDX_P);
			
			colorStep = (humidity - 20) / ((90 - 20) / 5);
			rgbLedColor = (4 < loopCount) ? 0 : GetRgbLedColor(loopCount, colorStep, RGBLED_BV_B);
		}
		segDP = (keta == LED1 || keta == LED3) ? SEG_DP : 0;
		
		//\
		//EZOgA`DP̓\[XA̓VNB
		DisplsyOff();
		PORTB = pgm_read_byte(&SEGCHAR[segidx[keta]]) | segDP;
		PORTC &= ~(1 << keta);
		
		//RGB-LEDwFœ_
		//ER,G,Be̓VNB
		LedOff();
		PORTD &= ~rgbLedColor;
		
		//_Ci~bNhCǔw
		keta = (keta + 1) % 4;
		
	}	//while()
	
	return 0;
	
}	//main()


//^C}[֌W̕ϐZbg
static	void	ResetTimerParam()
{
	TCNT1 = 0;
	timerCount = 0;
	doMeasure = 0;
}

//7ZO̕\
static	void	DisplsyOff()
{
	PORTB = 0;
	PORTC |= SEG_KETA_MASK;
}

//RGB-LED
static	void	LedOff()
{
	PORTD |= RGBLED_MASK;
}

//7ZOɎxEx̕\eZbg
//F	hutemType,hutemUnit:	7ZÕCfbNX
//			hutemValue:	xEx̑l
static	void	SetSegValue(uint8_t hutemType, uint8_t hutemValue, uint8_t hutemUnit)
{
	segidx[LED1] = hutemType;
	segidx[LED2] = hutemValue / 10;
	segidx[LED3] = hutemValue % 10;
	segidx[LED4] = hutemUnit;
}

//RGB-LED̐F擾
/*
΂Ԃ5iKi--ԁjc0`50'C
R:01234
G:43210
	
΂5iKi-F-jc20`90
B:01234
G:43210
*/
static	uint8_t	GetRgbLedColor(uint8_t loopCount, uint8_t colorStep, uint8_t colorBitValue)
{
	uint8_t rgbLedBit = 0;
	
	if (4 < colorStep) colorStep = 4;
	if (loopCount <= colorStep) rgbLedBit |= colorBitValue;
	if (loopCount <= 4 - colorStep) rgbLedBit |= RGBLED_BV_G;
	
	return rgbLedBit;
}
